## lomiri-content-hub 2.0.0

=== CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

cmake_minimum_required(VERSION 3.5)

project(lomiri-content-hub VERSION 2.0.0)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(ENABLE_TESTS "Build tests" ON)
option(ENABLE_DOC "Build documentation" ON)
option(ENABLE_UBUNTU_COMPAT "Enable Ubuntu.Content QML compatibility layer" OFF)

include (GNUInstallDirs)
find_package(GSettings)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC -pthread")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -fno-strict-aliasing -fPIC -pthread -Wno-unused-function -Wall -Wextra -pedantic")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

option(Werror "Treat warnings as errors" ON)

if (Werror)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()


# Workaround for libexecdir on debian
if (EXISTS "/etc/debian_version")
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}")
endif()

set(pkglibexecdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt5Core)
find_package(Qt5DBus)
find_package(Qt5Gui)
find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0)
pkg_check_modules(GIO REQUIRED gio-unix-2.0)
pkg_check_modules(LOMIRI_LAUNCH REQUIRED lomiri-app-launch-0)
pkg_check_modules(GSETTINGS REQUIRED gsettings-qt)
pkg_check_modules(LOMIRI_API REQUIRED liblomiri-api)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(LOMIRI_DOWNLOAD_MANAGER REQUIRED lomiri-download-manager-client)
pkg_check_modules(NOTIFY REQUIRED libnotify)
pkg_check_modules(APPARMOR REQUIRED libapparmor)

pkg_check_modules(LIBERTINE libertine)
if(LIBERTINE_FOUND)
   message("Building with libertine support")
else()
   message(WARNING "Building without libertine support")
endif()

add_definitions(-DDEBUG_ENABLED)

set(GETTEXT_PACKAGE "lomiri-content-hub")
add_definitions(-DI18N_DOMAIN="${GETTEXT_PACKAGE}")

set(CONTENT_HUB_VERSION_MAJOR 1)
set(CONTENT_HUB_VERSION_MINOR 0)
set(CONTENT_HUB_VERSION_PATCH 0)
set(CONTENT_HUB_VERSION "${CONTENT_HUB_VERSION_MAJOR}.${CONTENT_HUB_VERSION_MINOR}.${CONTENT_HUB_VERSION_PATCH}")

set(QML_API_VERSION_MAJOR 1)

include_directories(include)

if (${ENABLE_DOC})
  add_subdirectory(doc)
endif()
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(import)
add_subdirectory(examples)
add_subdirectory(tools)

install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Build and install a pkg-config file
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_FULL_BINDIR})
set(libdir ${CMAKE_INSTALL_FULL_LIBDIR})
set(includedir ${CMAKE_INSTALL_FULL_INCLUDEDIR})
set(pkg-name "liblomiri-content-hub")
set(glib-pkg-name "liblomiri-content-hub-glib")
configure_file(liblomiri-content-hub.pc.in liblomiri-content-hub.pc @ONLY)
configure_file(liblomiri-content-hub-glib.pc.in liblomiri-content-hub-glib.pc @ONLY)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/liblomiri-content-hub.pc
  ${CMAKE_CURRENT_BINARY_DIR}/liblomiri-content-hub-glib.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

if (${ENABLE_TESTS})
  enable_testing()
  find_package(CoverageReport)

  #####################################################################
  # Enable code coverage calculation with gcov/gcovr/lcov
  # Usage:
  #  * Switch build type to coverage (use ccmake or cmake-gui)
  #  * Invoke make, make test, make coverage
  #  * Find html report in subdir coveragereport
  #  * Find xml report feasible for jenkins in coverage.xml
  #####################################################################
  IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

  add_subdirectory(tests)

# There's no nice way to format this. Thanks CMake.
  add_test(LGPL-required
    /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src/client ${PROJECT_SOURCE_DIR}/include/client ${PROJECT_SOURCE_DIR}/src/shared ${PROJECT_SOURCE_DIR}/include/shared"
  )
  add_test(GPL-required
    /bin/sh -c "! grep -rl 'GNU Lesser' ${PROJECT_SOURCE_DIR}/src/server ${PROJECT_SOURCE_DIR}/include/server ${PROJECT_SOURCE_DIR}/include/test ${PROJECT_SOURCE_DIR}/tests ${PROJECT_SOURCE_DIR}/examples"
  )
endif()

=== tools/CMakeLists.txt ===
# Copyright © 2015 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

add_subdirectory(send)

=== doc/qml/CMakeLists.txt ===
# add a target to generate API documentation with qdoc
SET(QDOC_WORKS FALSE)
SET(ENV{QT_SELECT} qt5)
FIND_PROGRAM(QDOC_EXECUTABLE qdoc)
if(QDOC_EXECUTABLE)
EXECUTE_PROCESS(COMMAND ${QDOC_EXECUTABLE} --version OUTPUT_VARIABLE QDOC_OUTPUT ERROR_QUIET)
string(REGEX REPLACE "qdoc ([0-9]+(\\.[0-9]+)+).*" "\\1" QDOC_VERSION ${QDOC_OUTPUT})
if(QDOC_VERSION MATCHES "^5\\.")
set(QDOC_WORKS TRUE)
endif()
endif(QDOC_EXECUTABLE)
if(QDOC_WORKS)
message(STATUS "Check for working qdoc: ${QDOC_EXECUTABLE} (version: \"${QDOC_VERSION}\") -- works")
elseif(QDOC_EXECUTABLE)
message(FATAL_ERROR "Check for working qdoc: ${QDOC_EXECUTABLE} -- does not work")
else()
message(FATAL_ERROR "Check for working qdoc: not found")
endif(QDOC_WORKS)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/lomiri-content-hub.qdocconf.in ${CMAKE_CURRENT_BINARY_DIR}/lomiri-content-hub.qdocconf @ONLY)
add_custom_target(qmldoc
${QDOC_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/lomiri-content-hub.qdocconf
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
COMMENT "Generating QML API documentation with qdoc" VERBATIM
)

# copy stylesheet files into build directory for shadow builds
file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/css"
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
    )

install(
  DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/
  DESTINATION ${CMAKE_INSTALL_DOCDIR}/qml/html
)

add_dependencies(doc qmldoc)

=== examples/exporter/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  exporter

  exporter.cpp
  exampleexporter.cpp
)

target_link_libraries(exporter Qt5::Core Qt5::Gui Qt5::DBus)

set_target_properties(
  exporter
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  exporter
 
  lomiri-content-hub 
)

=== examples/importer/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  importer

  importer.cpp
  exampleimporter.cpp
  example.cpp
)

target_link_libraries(importer Qt5::Core Qt5::Gui Qt5::DBus)

set_target_properties(
  importer
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  importer
 
  lomiri-content-hub 
)

=== examples/pasteboard/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  copy-to-pasteboard

  copy.cpp
)

target_link_libraries(copy-to-pasteboard Qt5::Core Qt5::Gui Qt5::DBus)

set_target_properties(
  copy-to-pasteboard
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  copy-to-pasteboard
  lomiri-content-hub 
)

add_executable(
  paste-from-pasteboard

  paste.cpp
)

target_link_libraries(paste-from-pasteboard Qt5::Core Qt5::Gui Qt5::DBus)

set_target_properties(
  paste-from-pasteboard
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  paste-from-pasteboard
  lomiri-content-hub 
)

=== tests/acceptance-tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

project(test CXX C)

qt5_wrap_cpp(MOCS test_harness.h)
add_custom_target(generated_test_harness DEPENDS ${MOCS})

set(TESTS
  app_hub_communication_default_source
  app_hub_communication_known_sources
  app_hub_communication_stores
  app_hub_communication_store_migration
  app_hub_communication_transfer
  app_hub_communication_paste
  app_hub_communication_handler
  test_utils
  test_types
  mimedata_test
  glib_test
)

set(TEST_LIBS
  ${GMOCK_LIBRARIES}
  ${GTEST_BOTH_LIBRARIES}
  lomiri-content-hub
)

foreach(test ${TESTS})
  # set the sources per test
  set(${test}_SOURCES
    ${test}.cpp
    ${MOCS}
  )

  # set targets, linked libs and test
  add_executable(${test}
    ${${test}_SOURCES}
  )
  find_package(Qt5Test REQUIRED)
  target_link_libraries(${test} Qt5::Core Qt5::Gui Qt5::DBus Qt5::Test)

  target_link_libraries(${test}
    ${TEST_LIBS}
  )

  add_dependencies(${test} transfer_files generated_test_harness)

  add_test(NAME ${test} COMMAND dbus-test-runner --task ${CMAKE_CURRENT_BINARY_DIR}/${test})

  SET_TESTS_PROPERTIES(${test}
    PROPERTIES ENVIRONMENT "LOMIRI_CONTENT_HUB_TESTING=1")
endforeach(test)

add_executable(
  test_registry_updater
  test_registry_updater.cpp
  ${MOCS}
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content/service/registry-updater.cpp
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content/service/registry.cpp
  good.json
  bad.json
  source_all.json
)

target_link_libraries(test_registry_updater Qt5::Core Qt5::Gui Qt5::DBus Qt5::Test)
target_link_libraries(test_registry_updater ${TEST_LIBS} ${GSETTINGS_LDFLAGS})
add_test(NAME test_registry_updater COMMAND dbus-test-runner --task ${CMAKE_CURRENT_BINARY_DIR}/test_registry_updater)

SET_TESTS_PROPERTIES(test_registry_updater
  PROPERTIES ENVIRONMENT "LOMIRI_CONTENT_HUB_TESTING=1")

set_target_properties(
  test_registry_updater
  PROPERTIES
  AUTOMOC TRUE
)

file(COPY good.json bad.json source_all.json DESTINATION .)

target_link_libraries(glib_test lomiri-content-hub-glib)

add_custom_target(
  transfer_files
  COMMENT "Generating transfer test files"
  COMMAND ${CMAKE_COMMAND} -E touch file1 file2 file3
)

=== tests/qml-tests/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

set(TEST tst_QmlTests)
set(XVFB_CMD xvfb-run -a -s "-screen 0 640x480x24")
add_executable(${TEST} tst_QmlTests.cpp)
find_package(Qt5Quick REQUIRED)
find_package(Qt5QuickTest REQUIRED)
target_link_libraries(${TEST} Qt5::Core Qt5::Qml Qt5::Quick Qt5::Test Qt5::QuickTest)
add_test(NAME ${TEST} COMMAND ${XVFB_CMD} ${CMAKE_CURRENT_BINARY_DIR}/${TEST})
set_tests_properties(${TEST} PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal;QML2_IMPORT_PATH=${CMAKE_BINARY_DIR}/import;APP_ID=com.some.app.for.testing")

# copy qml files under test to build dir
set(out_qml_files)
if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml test files to build dir
  file(GLOB qmlTestFiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml)
  foreach(qmlTestFile ${qmlTestFiles})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${qmlTestFile}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${qmlTestFile}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${qmlTestFile} ${CMAKE_CURRENT_BINARY_DIR}/${qmlTestFile})
  endforeach(qmlTestFile)
  add_custom_target(copy_qml_test_files_to_build_dir DEPENDS ${qmlTestFiles})
  add_dependencies(${TEST} copy_qml_test_files_to_build_dir)
endif()

=== tools/send/CMakeLists.txt ===
# Copyright © 2015 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content
  ${LOMIRI_LAUNCH_INCLUDE_DIRS}
)

add_executable(
  lomiri-content-hub-send

  exporter.cpp
  autoexporter.cpp
  ${CMAKE_SOURCE_DIR}/src/com/lomiri/content/debug.cpp
)

target_link_libraries(lomiri-content-hub-send Qt5::Core Qt5::Gui Qt5::DBus)

set_target_properties(
  lomiri-content-hub-send
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  lomiri-content-hub-send
 
  lomiri-content-hub 
  ${LOMIRI_LAUNCH_LDFLAGS}
)

install(
  TARGETS lomiri-content-hub-send
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES lomiri-content-hub-send.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
    FILES lomiri-content-hub-send.url-dispatcher
    DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-url-dispatcher/urls
)

=== import/Lomiri/Content/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

project(lomiri-content-hub-plugin)

find_package(Qt5Quick REQUIRED)
set(CMAKE_AUTOMOC TRUE)

set(QT_IMPORTS_DIR "${CMAKE_INSTALL_LIBDIR}/qt5/qml")
set(CONTENT_HUB_IMPORTS_DIR "${QT_IMPORTS_DIR}/Lomiri/Content")

set(PLUGIN lomiri-content-hub-plugin)

add_definitions(-DQT_NO_KEYWORDS)

if (ENABLE_UBUNTU_COMPAT)
    add_definitions(-DENABLE_UBUNTU_COMPAT)
endif ()

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${LOMIRI_API_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${LOMIRI_LAUNCH_INCLUDE_DIRS}
)

set(PLUGIN_HDRS
    contenthandler.h
    contenthub.h
    contenthubplugin.h
    contenticonprovider.h
    contentitem.h
    contentpeer.h
    contentpeermodel.h
    contentscope.h
    contentstore.h
    contenttransfer.h
    contenttype.h
    qmlimportexporthandler.h
    )

set(PLUGIN_SRC
    contenthandler.cpp
    contenthub.cpp
    contenthubplugin.cpp
    contenticonprovider.cpp
    contentitem.cpp
    contentpeer.cpp
    contentpeermodel.cpp
    contentscope.cpp
    contentstore.cpp
    contenttransfer.cpp
    contenttype.cpp
    qmlimportexporthandler.cpp
    ../../../src/com/lomiri/content/debug.cpp
    )

add_library(${PLUGIN} MODULE ${PLUGIN_SRC} ${PLUGIN_HDRS})

target_link_libraries(${PLUGIN} Qt5::Core Qt5::Qml Qt5::Quick Qt5::DBus)
target_link_libraries(
    ${PLUGIN}
    lomiri-content-hub
    ${LOMIRI_API_LIBRARIES}
    ${GLIB_LIBRARIES}
    ${LOMIRI_LAUNCH_LDFLAGS}
)

install(TARGETS ${PLUGIN} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/qmldir DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

file(GLOB QML_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.qml qmldir)
install(FILES ${QML_FILES} DESTINATION ${CONTENT_HUB_IMPORTS_DIR})

if(NOT ${CMAKE_CURRENT_BINARY_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  # copy qml files and assets over to build dir to be able to import them uninstalled
  foreach(_file ${QML_FILES})
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${_file}
                       DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_file}
                       COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${_file} ${CMAKE_CURRENT_BINARY_DIR}/${_file})
  endforeach(_file)
  add_custom_target(copy_files_to_build_dir DEPENDS ${QML_FILES})
  add_dependencies(${PLUGIN} copy_files_to_build_dir)
endif()

if(NOT CMAKE_CROSSCOMPILING)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    COMMAND qmlplugindump -noinstantiate -notrelocatable Lomiri.Content 1.1 ../../ > ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes
    DEPENDS ${PLUGIN}
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

add_custom_target(Content_generated_files ALL SOURCES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/plugins.qmltypes DESTINATION ${CONTENT_HUB_IMPORTS_DIR})
endif()

=== tests/peers/exporter/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  lomiri-content-hub-test-exporter

  exporter.cpp
  autoexporter.cpp
)

target_link_libraries(lomiri-content-hub-test-exporter Qt5::Core Qt5::Gui Qt5::DBus)
pkg_check_modules(APPARMOR REQUIRED libapparmor)

set_target_properties(
  lomiri-content-hub-test-exporter
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  lomiri-content-hub-test-exporter
 
  lomiri-content-hub 
  ${APPARMOR_LDFLAGS}
)

install(
  TARGETS lomiri-content-hub-test-exporter
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES lomiri-content-hub-test-exporter.json
  DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/peers
  RENAME lomiri-content-hub-test-exporter
)

install(
  FILES lomiri-content-hub-test-exporter.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
  FILES lomiri-content-hub-test-exporter.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps/
)

=== tests/peers/importer/CMakeLists.txt ===
# Copyright © 2014 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Ken VanDine <ken.vandine@canonical.com>

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(
  lomiri-content-hub-test-importer

  importer.cpp
  autoimporter.cpp
)

target_link_libraries(lomiri-content-hub-test-importer Qt5::Core Qt5::Gui Qt5::DBus)

set_target_properties(
  lomiri-content-hub-test-importer
  PROPERTIES
  AUTOMOC TRUE
)

target_link_libraries(
  lomiri-content-hub-test-importer
 
  lomiri-content-hub 
)

install(
  TARGETS lomiri-content-hub-test-importer
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  FILES lomiri-content-hub-test-importer.json
  DESTINATION ${CMAKE_INSTALL_DATADIR}/lomiri-content-hub/peers
  RENAME lomiri-content-hub-test-importer
)

install(
  FILES lomiri-content-hub-test-importer.desktop
  DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(
  FILES lomiri-content-hub-test-importer.png
  DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps/
)

=== debian/changelog ===
lomiri-content-hub (2.0.0-5) unstable; urgency=medium

  * debian/control:
    + Add B:/R: (liblomiri-content-hub-dev) for old libcontent-hub-dev.
      (Closes: #1100377).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 13 Mar 2025 08:32:45 +0100

lomiri-content-hub (2.0.0-4) unstable; urgency=medium

  [ Mike Gabriel ]
  * debian/tests:
    + url-dispatcher: Fix URLs (use new namespace) in lomiri-content-hub-send
      calls.
    + Port tests from dbus-launch to dbus-run-session.
    + control: Add to D: xauth.

  [ Guido Berhoerster ]
  * debian/tests:
    + Improve test scripts
  * debian/tests/control:
    + Disable aa-check because AA policy cannot be enforced on Debian:
      On Debian SO_PEERSEC fails (see #1092591) and DBus is unable to determine
      the security context of the caller which will lead lomiri-content-hub to
      always grant access.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 09 Jan 2025 17:07:54 +0100

lomiri-content-hub (2.0.0-3) unstable; urgency=medium

  * debian/control:
    + Drop from P: (lomiri-content-hub): content-hub. Breaks installation of
      lomiri-desktop-session.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 12 Sep 2024 11:36:59 +0200

lomiri-content-hub (2.0.0-2) unstable; urgency=medium

  * Re-upload as is to unstable.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 08 Sep 2024 22:37:17 +0200

lomiri-content-hub (2.0.0-1) experimental; urgency=medium

  * Upload to experimental.

  * New upstream release.
    - Rename content-hub to lomiri-content-hub.
  * debian/:
    + Adjust packaging to namespacing to namespace changes upstream.
  * debian/copyright:
    + Update auto-generated copyright.in file.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 06 Sep 2024 23:23:23 +0200

content-hub (1.1.1-2) unstable; urgency=medium

  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/control:
    + Bump Standards-Version to 4.7.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 May 2024 10:42:34 +0200

content-hub (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0001_src_add_missing-symbols-in-Glib-compat-layer.patch. Applied
      upstream.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 13 Feb 2024 16:58:28 +0100

content-hub (1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/libcontent-hub1.symbols:
    + Drop file. Stop continuing .symbols for C++ files.
  * debian/libcontent-hub-glib1.symbols:
    + Update symbols.
  * debian/patches:
    + Add 0001_src_add_missing-symbols-in-Glib-compat-layer.patch. Don't
      remove symbols from API, continue having them via stubs.
  * debian/control:
    + qml-module-lomiri-content: Add Multi-Arch: same.
    + libcontent-hub-doc, qml-module-lomiri-content-doc: Add Multi-Arch:
      foreign.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 08 Feb 2024 09:38:11 +0100

content-hub (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 14 Feb 2023 12:06:02 +0100

content-hub (1.0.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/patches:
    + Drop all patches. They are included in this upstream version.
  * lintian:
    + Adjust to new syntax.
  * debian/libcontent-hub1.symbols:
    + Update symbols.
  * debian/rules:
    + Make sure the 'symlinks' command dives into the API doc's subtree.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 05 Feb 2023 01:00:01 +0100

content-hub (1.0.0-7) unstable; urgency=medium

  [ Anton Gladky]
  * Add d/.gitlab-ci.yml

  [ Marius Gripsgard ]
  * [debian/*.symbols] Mark unused symbols that would otherwise be optimized out

 -- Marius Gripsgard <marius@ubports.com>  Sat, 07 Jan 2023 21:42:02 +0100

content-hub (1.0.0-6) unstable; urgency=medium

  * Team upload.

  * debian/libcontent-hub1.symbols:
    + Update symbols for armel, armhf and i386.

 -- Anton Gladky <gladk@debian.org>  Mon, 10 Oct 2022 21:01:09 +0200

content-hub (1.0.0-5) unstable; urgency=medium

  * Team upload.

  [ Mike Gabriel ]
  * debian/: Update upstream Git repo URL.

  [ Anton Gladky ]
  * debian/libcontent-hub1.symbols:
    + Update symbols due to gcc-12. (Closes: #1016248)

 -- Anton Gladky <gladk@debian.org>  Mon, 10 Oct 2022 07:28:25 +0200

content-hub (1.0.0-4) unstable; urgency=medium

  * debian/libcontent-hub1.symbols:
    + Update symbols for riscv64 and armel. (Closes: #1014126).

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 03 Jul 2022 22:26:02 +0200

content-hub (1.0.0-3) unstable; urgency=medium

  * debian/patches: Update patches from upstream repo:
    + Rename 1003 to 0007 (and cherry-pick from upstream).
    + Drop 1004 in favour of 0008 (cherry-picked from upstream).
    + Rename 0002 to 0006.
    + Add 0009 and 0011.
  * debian/content-hub.install:
    + Adjust (lomiri-)url-dispatcher schema path.
  * debian/tests/:
    + Silence various dconf related warnings.
    + Disable aa-check test for now. This needs closer investigation.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 03 Jul 2022 11:57:49 +0200

content-hub (1.0.0-2) unstable; urgency=medium

  * Re-upload source-only as is.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Mar 2022 20:42:53 +0100

content-hub (1.0.0-1) unstable; urgency=medium

  * Initial release to Debian. (Closes: #1001993).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 01 Feb 2022 23:21:17 +0100

=== debian/control ===
Source: lomiri-content-hub
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               dbus-test-runner <!nocheck>,
               debhelper-compat (= 13),
               dh-apparmor,
               doxygen <!nodoc>,
               google-mock <!nocheck>,
               libgtest-dev,
               lcov <!nocheck>,
               libapparmor-dev,
               libdbus-1-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
#               liblibertine-dev,
               liblomiri-api-dev,
               libnotify-dev,
               liblomiri-download-manager-client-dev,
               liblomiri-app-launch-dev (>= 0.1.1),
               qml-module-lomiri-components,
               qml-module-qtquick2,
               qml-module-qttest <!nocheck>,
               qml-module-qtqml-workerscript2,
               qtbase5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qttools5-dev-tools,
               rdfind,
               symlinks,
               xvfb <!nocheck>,
               xauth,
Standards-Version: 4.7.0
Section: misc
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-content-hub
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-content-hub.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-content-hub/

Package: lomiri-content-hub
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Replaces: content-hub (<< 2.0.0)
Breaks: content-hub (<< 2.0.0)
Description: content sharing/picking service for Lomiri
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes the content sharing service.

Package: liblomiri-content-hub1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: lomiri-content-hub
Description: content sharing/picking library for Lomiri
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes the content sharing libraries.

Package: liblomiri-content-hub-glib1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: lomiri-content-hub
Description: content sharing/picking library for Lomiri - GLib bindings
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 This package includes GLib bindings of the content sharing libraries.

Package: liblomiri-content-hub-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-content-hub1 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libcontent-hub-dev,
Replaces: libcontent-hub-dev,
Description: content sharing development files for Lomiri
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 All the development headers and libraries for the content hub

Package: liblomiri-content-hub-glib-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-content-hub-glib1 (= ${binary:Version}),
         ${misc:Depends},
Description: content sharing development files for Lomiri - GLib bindings
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 GLib bindings of the development headers and libraries for the content hub

Package: qml-module-lomiri-content
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: liblomiri-content-hub1,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends},
Multi-Arch: same
Description: QML binding for Lomiri's liblomiri-content-hub
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 QML bindings for liblomiri-content-hub

Package: liblomiri-content-hub-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: Documentation files for Lomiri's liblomiri-content-hub-dev
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 Documentation files for the liblomiri-content-hub development

Package: qml-module-lomiri-content-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
Multi-Arch: foreign
Description: Documentation files for QML module Lomiri Content
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 Documentation files for QML development.

Package: lomiri-content-hub-testability
Architecture: any
Build-Profiles: <!noinsttest>
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-content-hub,
Replaces: content-hub-testability (<< 2.0.0),
Breaks: content-hub-testability (<< 2.0.0),
Provides: content-hub-testability (= ${binary:Version}),
Description: content sharing testability for Lomiri
 Content sharing/picking infrastructure and service, designed to allow apps to
 securely and efficiently exchange content.
 .
 Files and utilities needed for automated testing of content-hub

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export CONTENT_HUB_TESTING=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/buildflags.mk

ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  CONFIGURE_OPTS += -DENABLE_TESTS=OFF
  DEB_BUILD_PROFILES += noinsttest
endif

ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  CONFIGURE_OPTS += -DENABLE_DOC=OFF
endif

%:
	dh $@ $(PROJECT_DH_OPTIONS) -- -B build

override_dh_auto_test:
	dh_auto_test --no-parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTS)

override_dh_auto_install:
ifneq (,$(findstring nocheck,$(DEB_BUILD_PROFILES)))
	mkdir -p debian/lomiri-content-hub-testability
endif
	dh_auto_install
	dh_apparmor -plomiri-content-hub-testability --profile-name=lomiri-content-hub-testability
	mkdir -p debian/tmp/var/cache/lomiri-content-hub/peers

override_dh_install:
	rmdir debian/tmp/usr/share/doc/lomiri-content-hub/qml/html/images/
	cd debian/tmp/usr/share/doc/lomiri-content-hub/cpp/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri-content-hub/cpp/html/ && symlinks -rc .
	cd debian/tmp/usr/share/doc/lomiri-content-hub/qml/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri-content-hub/qml/html/ && symlinks -rc .
	dh_install

override_dh_missing:
	dh_missing --fail-missing

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
